#ifndef RENDERER_HPP_TZURAY
#define RENDERER_HPP_TZURAY
#include "View.hpp"
#include "rgbSurface.h"
#include "PointLight.hpp"
#include "Primative.hpp"
#include "Scene.hpp"
struct RTInfo {
	bool intersected;
	PointLight *p;
	float shortest;
	CVector isctshort;
	bool shadowTrace; // Are we tracing for shadow?	
	bool reflectTrace;
	CVector vExclude; // better
	//Primative *exclude;
	CVector lightpos; // for shadowtrace
	float dShadow; // The shadow distance
	
	
};
class Renderer {
	
	
	public:
	Renderer();
	bool ShadowTrace (Ray *, RTInfo *, Primative *);
	rgb24 RayTrace (Ray *, RTInfo *);
	View theView;
	void Render(int, int,rgbSurface *);
	PointLight p;
	Scene scene;
	
	
	

};
#endif
