
#ifndef BASE_HPP_TZURAY
#define BASE_HPP_TZURAY
#include <map>
#include "CVector.hpp"
#include "Ray.hpp"
#include "Primative.hpp"
#include "rgbSurface.h"
// All your base.hpp are belong to us.. oh lol
using namespace std;
struct floatColor {
	float r,g,b,a;
};
struct Primative;
struct Intersection  {
	CVector point;
	CVector normal;
	float dist;
	Ray *ray;
	Primative *object;	
	rgb24 color;
	floatColor fcolor;
	
	
};

class IntersectionList {
	private:
	map <float, Intersection*> internal;	// Intersections are sorted by their distace.. nuff said.
	long numIsct;
	public:
	void add (Intersection*);	
	Intersection *get (float);
	Intersection *getNearest();
	long getNumIntersections();	
		
};
extern IntersectionList isctlist;
#endif
