#include "CVector.hpp"

CVector::CVector (Vector v) {
	internal = v;
}

CVector::CVector (float x, float y, float z) {
	internal.x=x;internal.y=y;internal.z=z; // so basic
}
Vector *CVector::getInternal () {  // Yuck!! :P pfft
	return &internal; 
}
CVector CVector::operator+ (CVector v1, CVector v2) {
Vector *v1i, *v2i;
v1i = v1.getInternal();
v2i = v2.getInternal();
return CVector(VectorAdd(*v1i, *v2i));
}
CVector CVector::operator- (CVector v1, CVector v2) {
Vector *v1i, *v2i;
v1i = v1.getInternal();
v2i = v2.getInternal();
return CVector(VectorSub(*v1i, *v2i));
}
CVector CVector::operator* (CVector v1, CVector v2) {
Vector *v1i, *v2i;
v1i = v1.getInternal();
v2i = v2.getInternal();
return CVector(VectorDot(*v1i, *v2i));
}
CVector CVector::operator- (CVector v1) {
return CVector(0,0,0)-v1;
}
CVector CVector::operator% (CVector v1, CVector v2) {
Vector *v1i, *v2i;
v1i = v1.getInternal();
v2i = v2.getInternal();
return CVector(VectorCross(*v1i, *v2i));
}

void Normalize() {
	VectorNormalize(internal);
}
void Rotate (float ax, float ay, float az) {
	VectorRotate(internal, ax, ay, az);
}