#ifndef CVECTOR_HPP_TZURAY
#define CVECTOR_HPP_TZURAY
#include "vector.h"

class CVector {
Vector internal;
public:

CVector(Vector);
CVector(float x, float y, float z);
CVector();
Vector *getInternal ();
float operator* (CVector ); // Dot Product
CVector operator*(float); // Multiply
CVector operator/(float); // Divide
CVector operator% (CVector ); // Cross Product
CVector operator+ (CVector ); // Add
CVector operator- (CVector ); // Subtract
CVector operator- ();
CVector operator= (Vector);
CVector operator= (float[2]);
void Normalize();
void Rotate(float ax, float ay, float az);


};
CVector operator*(float, CVector);
#endif