#include "DiffuseShader.hpp"
#include <iostream>
using namespace std;
DiffuseShader::DiffuseShader() {
	type = S_DIFFUSE;
}
void DiffuseShader:: ShaderFunc(PointLight *p, Shading_Info * s){
	CVector vLight = p->position - s->IntersectionPoint;
	float Angle;
	vLight.Normalize();
	Angle  = s->Normal * vLight;
		
		if (Angle < 0) {s->color.r=0;s->color.g=0;s->color.b=0; return;}
	float diffstuff = diff * p->diff * Angle;
	s->color.r = s->color.r * (diffstuff);
	s->color.g = s->color.g * (diffstuff);
	s->color.b = s->color.b * (diffstuff);
	Ray *r = s->r;
	/*
	CVector refVect = 2 * (s->Normal * r->vDir) * s->Normal - r->vDir;
	float specAngle = refVect * ( -r->vDir); // You're welcome to fix me if you like!
	if (specAngle > 0) {
		float specstuff = pow (specAngle, shiny) * spec * p->spec;
		s->color.r = sColor[0] * specstuff * 255;
		s->color.g = sColor[1] * specstuff * 255;
		s->color.b = sColor[2] * specstuff * 255;
	}
	*/
}	
