
#include "Plane.hpp"

Plane::Plane() {
	type = P_PLANE;	
}
Plane::Plane(CVector Nor, float Dist) {
	Normal = Nor;
	Distance = Dist;
	type = P_PLANE;
}

bool Plane::Intersect(Shading_Info *s, Ray *r) {


	float t = (r->vDir * Normal) / - ( (Normal * r->vStart) + Distance);
	
	if (t == 0) {
		return false; // We have a miss.. I repeat we have a miss.. PULL OUT PULL OUT.. OH :)
	}
	else {
		
		s->IntersectionPoint = r->vStart + r->vDir * (t);
		s->Normal = Normal;
		s->color.r = color.r;
		s->color.g = color.g;
		s->color.b = color.b;

		return true; // Ladies and gentelmen.. we have a hit
	}
}
