#ifndef SHADER_HPP_TZURAY
#define SHADER_HPP_TZURAY
#define S_PLUGIN -2
#define S_NONE -1
#define S_DIFFUSE 0
#define S_PHONG 1
#define S_LAMBERT 2


#include "PointLight.hpp"
#include "Ray.hpp"

#include "rgbSurface.h"
struct Shading_Info {
	rgb24 color;
	float fColor;
	byte alpha;
	CVector IntersectionPoint;
	CVector Normal;	
	float emit;
	Ray *r;
	float dist;
	void *rend;
};
class Shader {
	protected:
	long type;
	public:
	Shader();
	long getType();
	void ShaderFunc(PointLight* , Shading_Info *);
};

#endif
