#include "CVector.hpp"

CVector operator*(float f, CVector v) {
return v * f;
}
CVector::CVector (Vector v) {
	internal = v;
}
CVector::CVector() {
}
CVector::CVector (float x, float y, float z) {
	internal.x=x;internal.y=y;internal.z=z; // so basic
}
Vector *CVector::getInternal () {  // Yuck!! :P pfft
	return &internal; 
}
CVector CVector::operator+ (CVector v2) {
Vector *v1i, *v2i;

v2i = v2.getInternal();
return CVector(VectorAdd(*(this->getInternal()), *v2i));
}
CVector CVector::operator- (CVector v2) {
Vector *v1i, *v2i;

v2i = v2.getInternal();
return CVector(VectorSub(*(this->getInternal()), *v2i));
}
CVector CVector::operator* (float p) {
	return CVector(internal.x * p, internal.y * p, internal.z * p);
}
CVector CVector::operator/ (float p) {
	return CVector(internal.x / p, internal.y / p, internal.z / p);
}
float CVector::operator* (CVector v2) {
Vector *v1i, *v2i;

v2i = v2.getInternal();
return VectorDot(*(this->getInternal()), *v2i);
}
CVector CVector::operator- () {
return CVector(0,0,0)-*this;
}
CVector CVector::operator% (CVector v1) {
Vector *v1i, *v2i;

v2i = v1.getInternal();
return CVector(VectorCross(*(this->getInternal()), *v2i));
}

void CVector::Normalize() {
	VectorNormalize(internal);
}
void CVector::Rotate (float ax, float ay, float az) {
	VectorRotate(internal, ax, ay, az);
}
CVector CVector::operator= (Vector v) {
	return CVector(v);
}
CVector CVector::operator= (float f[2] ) {
	return CVector  (f[0], f[1], f[2]);
}
bool CVector::operator> (CVector v) {
	return (internal.x > v.getInternal()->x) && (internal.y > v.getInternal()->y) && (internal.z > v.getInternal()->z);
}
bool CVector::operator< (CVector v) {
	return (internal.x < v.getInternal()->x) && (internal.y < v.getInternal()->y) && (internal.z < v.getInternal()->z);
}
bool CVector::operator== (CVector v) {
	return (internal.x == v.getInternal()->x) && (internal.y == v.getInternal()->y) && (internal.z == v.getInternal()->z);
}
bool CVector::operator!= (CVector v) {
	return (internal.x != v.getInternal()->x) && (internal.y != v.getInternal()->y) && (internal.z != v.getInternal()->z);
}

