
// Rr = Ri - 2 N (Ri . N)

#include "Renderer.hpp"
#include "ReflectionShader.hpp"
#include <iostream>
using namespace std;
ReflectionShader::ReflectionShader () {
	type = S_REF;
}
void ReflectionShader::ShaderFunc (map <long, Light*> p, Shading_Info *s) {
	 
	CVector rr = 2 * (s->Normal * s->r->vDir) * s->Normal - s->r->vDir;
	
	Ray r(s->IntersectionPoint, rr);
	
	RTInfo ri;
	ri.shadowTrace = false; // We're not doing a shadow trace!
	ri.reflectTrace = true; // We're tracing for reflection.
	//ri.exclude = s->parent;
		
	s->color = s->rend->RayTrace (&r, &ri);
}

