#include "Renderer.hpp"
#include "Sphere.hpp"
#include "base.hpp"
#include "Plane.hpp"
#include "PointLight.hpp"
#include "DiffuseShader.hpp"
#include "Primative.hpp"
#include "PhongShader.hpp"
#include <iostream>
using namespace std;
Renderer::Renderer() {
}
//for (f=0; f < z; f++) {
//
//if (dbuffer[f] < dbuffer[lowest]) {
//	lowest = f;
//	in->shortest = dbuffer[f];
//	in->isctshort = ibuffer[f];

bool Renderer::ShadowTrace (Ray *r, RTInfo *in, Primative *parent) {
		map <long, float> dbuffer;
//	map <long, rgb24> cbuffer;
	map <long, CVector> ibuffer;
	long nObjects = scene.getNumObjects();
	Shading_Info inf;
	inf.rend = this;
	DiffuseShader* shd;
	PhongShader * shp;
	Primative *pri;
	Sphere *s;
	in->intersected = false; // just in case we dont have anythin in the scene
	Plane *p;
	rgb24 rg;
	long z=0; // # of intesections
	for (long i = 0; i < nObjects; i++) {
		
		pri = 	scene.getObject(i);
		if (pri != NULL) {
		if (pri->doIntersect(&inf,r)) {
			if (inf.IntersectionPoint == in->vExclude) { } else {
			if (parent->position < in->lightpos) {
			if (inf.IntersectionPoint < in->lightpos) {
			return true;	
			}
			else {
			return false;
			}
			
			}
			if (parent->position > in->lightpos) {
			if (inf.IntersectionPoint > in->lightpos) {
			return true;	
			}
			else {
			return false;
			}
			
			
			}
			
			} 
		} else {
			if (in->intersected == false) { in->intersected = false; }
		}

}
else {
	//cout << "OH CRAP " << i << endl;
}
}

return in->intersected;
}

rgb24 Renderer::RayTrace (Ray *r, RTInfo *in) {
	map <float, rgb24> dbuffer;
	
	r->ttl--;
	long nObjects = scene.getNumObjects();
	Shading_Info inf;
	inf.rend = this;
	DiffuseShader* shd;
	PhongShader * shp;
	Primative *pri;
	Sphere *s;
	in->intersected = false; // just in case we dont have anythin in the scene
	Plane *p;
	rgb24 rg;
	long z=0; // # of intesections
	for (long i = 0; i < nObjects; i++) {
		
		pri = scene.getObject(i);
		if (pri == NULL) {continue;}		
		
				
				if (pri->doIntersect(&inf, r)) {
				if (inf.numIsct==0) {continue;}
				cout << "ARGH!!! @#$%!!!!" << endl;
				for (int xi = 0; xi < inf.numIsct; xi++) {
				Intersection *c=(inf.i[xi]);
				inf.IntersectionPoint= c->point;
				inf.Normal = c->normal;
				inf.dist = c->dist;
				inf.r = c->ray;
				inf.color = c->color;
				inf.parent = c->object;
				inf.rend = this;
				
				/*struct Intersection  {
					CVector point;
					CVector normal;
					float dist;
					Ray *ray;
					Primative *object;	
					rgb24 color;
					floatColor fcolor;	
					};
				struct Shading_Info {
					rgb24 color;
					float fColor;
					byte alpha;
					CVector IntersectionPoint;
					CVector Normal;	
					float emit;
					Ray *r;
					Intersection *i;
					long numIsct;
					float dist;
					Renderer *rend;
					Primative *parent;
					};

*/

				
				pri->shader->doShader(scene.p, &inf);
				c->color = inf.color;
				
				in->intersected = true;
				}
				
				
				
				
				
				
			}
			else {
				if (!in->intersected) { // We havent hit anything yet
				in->intersected = false;
				}
			}
			}
			
		
	
if (!in->intersected) { return scene.skycolor;}else {
Intersection *i2 = isctlist.getNearest();
return i2->color;

}




}

void Renderer::Render(int w, int h, rgbSurface *rgb) {
rgb->w = w;
rgb->h = h;
rgb->data = new rgb24 [w*h];
Primative *prim;
RTInfo	ri;
rgb24 color;

for (int x=0; x < w; x++) {
	
	for (int y=0; y < h; y++) {
		
		float cx = (x - (w /2)) + theView.position.getInternal()->x; // Translate our pixels
		float cy = (y - (h/2)) + theView.position.getInternal()->y; // Translate our pixels
		Ray r(theView.position, CVector(cx,cy,theView.lookat.getInternal()->z)); // shoot our ray!!! w00tage
		ri.shadowTrace = false;
		ri.reflectTrace = false;
		color = RayTrace (&r, &ri);
		rgb->data [(rgb->w *y)  +x] = color;
	}

}
	
}

