#include "Sphere.hpp"
#include <iostream>
using namespace std;
#include <math.h>
Sphere::Sphere () {
	type = P_SPHERE;
}
Sphere::Sphere(CVector center, float r) {
	position = center; radius = r;
	type = P_SPHERE;
}
float Sphere::getRadius() {
	return radius;
}
void Sphere::setRadius(float r) {
	radius = r;
}

bool Sphere::Intersect (Shading_Info *s, Ray *r) {
	float p,  q;  // Our floats 
	float px;
	
	p = (r->vDir * (r->vStart - position)); // hehe
	q = ((r->vStart - position) * (r->vStart - position)) - radius*radius;
	px = p*p - q;
	 float t1, t2;
	 if (px < 0) {
		return false; // we missed
	 }
	 else {
	 		 	t1=-p+sqrt(px);
		t2=-p-sqrt(px);
		//if (t1 < t2) {
		//s->IntersectionPoint = r->vStart + r->vDir * (t1);
		//}
		//else {
		s->IntersectionPoint = r->vStart + r->vDir * (t2);
		//}
		s->r = r;
		s->Normal = (s->IntersectionPoint - position)/ radius;
		s->dist = t2;	
		s->color.r = color.r;
		s->color.g = color.g;
		s->color.b = color.b;

		return true; // We have a hit!! I repeat we have a hit w00tage!
	 }
	
	
}
